<template>
  <background class="row justify-center">
    <q-card class="col-lg-4 col-md-6 col-sm-10 col-xs-10 q-my-xl">
      <q-card-section>
        <h3>Přihlášení</h3>
        <h5>
          Testovací režim:<br>admin<br>admin1234
        </h5>
      </q-card-section>

      <q-separator inset />

      <q-card-section>
        <q-form
          class="q-gutter-md"
          @submit="onSubmit"
        >
          <q-input
            v-model="name"
            filled
            label="Vaše jméno *"
            lazy-rules
            :rules="[
              val => val && val.length > 0 || 'Prosím zadejte jméno'
            ]"
          />

          <q-input
            v-model="password"
            filled
            :type="isPwd ? 'password' : 'text'"
            label="Vaše heslo *"
            lazy-rules
            :rules="[
              val => val && val.length > 0 || 'Prosím zadejte heslo'
            ]"
          >
            <template #append>
              <q-icon
                :name="isPwd ? 'visibility_off' : 'visibility'"
                class="cursor-pointer"
                @click="isPwd = !isPwd"
              />
            </template>
          </q-input>

          <div>
            <q-btn
              label="Přihlásit se"
              :disable="loading"
              type="submit"
              color="primary"
              :loading="loading"
            >
              <template #loading>
                <q-spinner-gears />
              </template>
            </q-btn>
          </div>
        </q-form>
      </q-card-section>
    </q-card>
  </background>
</template>

<script lang="ts">

import { useQuasar } from 'quasar'
import { ref } from 'vue'
import { useRouter } from 'vue-router'

import background from '@/components/Background.vue'
import useUserStore from '@/store/userStore'

export default {
  name: 'SignIn',
  components: {
    background
  },

  setup (): any {
    const $q = useQuasar()
    const user = useUserStore()
    const router = useRouter()

    const name = ref('')
    const password = ref('')
    const isPwd = ref(true)
    const loading = ref(false)

    return {
      name,
      password,
      isPwd,
      loading,

      onSubmit () {
        loading.value = true

        user.signIn({
          name: name.value,
          password: password.value
        }).then(
          () => {
            $q.notify({
              type: 'positive',
              message: 'Byl jste úspěšně přihlášen'
            })

            router.push({ name: 'home' })
          })
          .finally(
            () => {
              loading.value = false
            }
          )
      }

    }
  }
}

</script>
